'use strict';

const delegateNormalizer = require('delegate-normalizer');

/**
 * Normalize configuration object received in the constructor
 * @param {Object} options - Configuration object
 * @return {Object}
 */
module.exports = function (options) {
  options = options || {};
  const conf = Object.create(null);

  conf.type = 'text';

  conf.width = options.width && typeof options.width === 'string'
    ? options.width
    : '100%';

  const v = Number(options.tabindex);
  conf.tabindex = Number.isInteger(v) ? v : 0;

  conf.validator = typeof options.validator === 'function'
    ? options.validator
    : function () { return true; };

  conf.onValueChange = delegateNormalizer(options.onValueChange);
  conf.onValidationStatusChange =
    delegateNormalizer(options.onValidationStatusChange);

  return conf;
};
