'use strict';

const test = require('tape');
const proxyquire = require('proxyquire').noPreserveCache();

/**
 * Fakes
 */

const stylesheetInjectorStub = function () {};
const optionsNormilizerStub = function () { return {}; };
const createElement = function () { return {}; };
const stylesStub = 'some_text';
const guidStub = 'some_text';

/**
 * TESTS
 */

test('index > constructor > Called without new', t => {
  const selfStub = proxyquire('../index', {
    'stylesheet-injector': stylesheetInjectorStub,
    './lib/normalize-options': optionsNormilizerStub,
    './lib/create-element': createElement,
    './lib/style.json': stylesStub,
    './lib/guid.json': guidStub
  });

  const result = selfStub();

  t.ok((result instanceof selfStub), 'Returns instance of Textinput');
  t.ok(result.config, 'Contains config property');
  t.ok(result.element, 'Contains element property');
  t.ok(result.element.instance, 'Contains cross reference element-instance');
  t.ok(result.isValid === true, 'isValid property is set to true');
  t.end();
});
